﻿Function Invoke-WMIQuery {
        $wmiClass = ($WMI_txtbx.Text).Trim()
    Try {        
        $Data = Get-WmiObject -ComputerName $Computer_txtbx.Text -Class $wmiClass -ErrorAction Stop
        $OutputBox.Foreground = "White"
        $OutputBox.Text = $Data | Out-String
    } Catch {
        $OutputBox.Foreground = "Red"
        $OutputBox.Text = $_.Exception.Message
    }
}
#Build the GUI
[xml]$xaml = @"
<Window 
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    x:Name="Window" Title="WMI Query" WindowStartupLocation = "CenterScreen" ResizeMode="NoResize"
    SizeToContent = "WidthAndHeight" ShowInTaskbar = "True" Background = "lightgray"> 
    <StackPanel Orientation = 'Horizontal'>
        <StackPanel>    
            <StackPanel Orientation = 'Horizontal'>  
                <Label Content = "Computername"/>        
                <TextBox x:Name="Computer_txtbx" Height = "25" Width = "122" AcceptsReturn="True" SpellCheck.IsEnabled="True" />   
            </StackPanel>
            <StackPanel Orientation = 'Horizontal'>  
                <Label Content = "WMI Class"/>        
                <TextBox x:Name="WMI_txtbx" Height = "25" Width = "150" AcceptsReturn="True" SpellCheck.IsEnabled="True" />   
            </StackPanel>            
            <StackPanel Orientation = 'Horizontal'>
                <Button x:Name = "query_btn" Height = "50" Width = "75" Content = 'Query' Background="Yellow"/>
                <Button x:Name = "clear_btn" Height = "50" Width = "75" Content = 'Clear' Background="Yellow" Margin = "50,0,0,0" />  
            </StackPanel>
        </StackPanel>    
        <TextBox x:Name="OutputBox" IsReadOnly = "True" Height = "300" Width = "500" TextWrapping="Wrap" 
        Background = "Black" Foreground = 'White' FontWeight = 'Bold' VerticalScrollBarVisibility = "Visible"/>            
    </StackPanel>
</Window>
"@
 
$reader=(New-Object System.Xml.XmlNodeReader $xaml)
$Window=[Windows.Markup.XamlReader]::Load( $reader )

#Connect to Controls
$query_btn = $Window.FindName('query_btn')
$clear_btn = $Window.FindName('clear_btn')
$OutputBox = $Window.FindName('OutputBox')
$Computer_txtbx = $Window.FindName('Computer_txtbx')
$WMI_txtbx = $Window.FindName('WMI_txtbx')

#Events
$query_btn.Add_Click({    
    Invoke-WMIQuery
})

$clear_btn.Add_Click({
    $OutputBox.Clear()
})

$Window.Add_KeyDown({
    If ($_.Key -eq "F5") {
        Invoke-WMIQuery
    }
})

$Window.ShowDialog() | Out-Null